#include <stdio.h>
#include <string.h>
#include "MullPop.h"

void BuildOverlapMatrix(void)
{

	int i;
	int nbasis;
	double *a_s;

	nbasis = basis + 1;

	a_s = malloc(nbasis * nbasis * sizeof(double));

	if(a_s == NULL)
	{
		printf(" Error during memory allocation for S\n\n");
		exit(1);
	}

	s = malloc(nbasis * sizeof(double *));

	if(s == NULL)
	{
		printf(" Error during memory allocation for S\n\n");
		exit(1);
	}

	for(i = 0; i < nbasis; i++)
		s[i] = a_s + (i * nbasis);
	
}
