#include <stdio.h>
#include <string.h>
#include "MullPop.h"

void BuildPopulationMatrix(void)
{

	int i;
	int nbasis;
	int natoms;
	double *a_s;
	double *b_s;
	double *c_s;
	double *d_s;

	nbasis = basis + 1;
	natoms = numberOfAtoms + 1;

	a_s = malloc(nbasis * nbasis * sizeof(double));

	if(a_s == NULL)
	{
		printf(" Error during memory allocation for population matrixes\n\n");
		exit(1);
	}

	grossPop_a = malloc(nbasis * sizeof(double *));

	if(grossPop_a == NULL)
	{
		printf(" Error during memory allocation for population matrixes\n\n");
		exit(1);
	}

	for(i = 0; i < nbasis; i++)
		grossPop_a[i] = a_s + (i * nbasis);

	c_s = malloc(natoms * nbasis * sizeof(double));

	if(c_s == NULL)
	{
		printf(" Error during memory allocation for population matrixes\n\n");
		exit(1);
	}

	reducedPop_a = malloc(natoms * sizeof(double *));

	if(reducedPop_a == NULL)
	{
		printf(" Error during memory allocation for population matrixes\n\n");
		exit(1);
	}

	for(i = 0; i < natoms; i++)
		reducedPop_a[i] = c_s + (i * nbasis);

	if(spin == 1)
	{

		b_s = malloc(nbasis * nbasis * sizeof(double));

		if(b_s == NULL)
		{
			printf(" Error during memory allocation for population matrixes\n\n");
			exit(1);
		}

		grossPop_b = malloc(nbasis * sizeof(double *));

		if(grossPop_b == NULL)
		{
			printf(" Error during memory allocation for population matrixes\n\n");
			exit(1);
		}

		for(i = 0; i < nbasis; i++)
			grossPop_b[i] = b_s + (i * nbasis);

		d_s = malloc(natoms * nbasis * sizeof(double));

		if(d_s == NULL)
		{
			printf(" Error during memory allocation for population matrixes\n\n");
			exit(1);
		}

		reducedPop_b = malloc(natoms * sizeof(double *));

		if(reducedPop_b == NULL)
		{
			printf(" Error during memory allocation for population matrixes\n\n");
			exit(1);
		}

		for(i = 0; i < natoms; i++)
			reducedPop_b[i] = d_s + (i * nbasis);
	}		

}
